//////////////////////////////////////////////////////////////
//
//  Description	: PDF Split-Merge software
//  Author	: verypdf.com Inc
//  Version	: Ver 1.1
//  Platform	: Windows95/98/Me/NT/2000/XP
//  Environment	: Visual C++ 6.0
//  Date	: 2004/01/01
//
//  Copyright(C) 2003--2004 verypdf.com Inc
//      
//  Contact infomation:
//        http://www.verypdf.com/
//        support@verypdf.com
//
//  This program is shareware; you can redistribute and/or 
//  modify it under the terms of the GNU General Public License.
//  See the GNU General Public License for more details.
//
//         Portion base on iText Java Library
//            http://www.lowagie.com/iText/
//////////////////////////////////////////////////////////////
// PDFSplit.cpp : implementation file
//

#include "stdafx.h"
#include "pdfpage.h"
#include "PDFSplit.h"
#include "sbdestination.h"
#include "About.h"
#include "Redirect.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPDFSplit property page

IMPLEMENT_DYNCREATE(CPDFSplit, CPropertyPage)

CPDFSplit::CPDFSplit() : CPropertyPage(CPDFSplit::IDD)
{
	//{{AFX_DATA_INIT(CPDFSplit)
	m_strSourcePDF = _T("");
	m_strPageOption = _T("1");
	m_strOutputDir = _T("C:\\");
	m_bCheckOutput = FALSE;
	m_bSplitAllPages = TRUE;
	//}}AFX_DATA_INIT
}

CPDFSplit::~CPDFSplit()
{
}

void CPDFSplit::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPDFSplit)
	DDX_Control(pDX, IDC_EDIT_OUTPUT1, m_ctrlLogOutput);
	DDX_Text(pDX, IDC_EDIT_SOURCEPDF, m_strSourcePDF);
	DDX_Text(pDX, IDC_EDIT_PAGES_OPTION, m_strPageOption);
	DDX_Text(pDX, IDC_EDIT_OUTPUTDIR, m_strOutputDir);
	DDX_Check(pDX, IDC_CHECK_SAMEASSOURCE, m_bCheckOutput);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPDFSplit, CPropertyPage)
	//{{AFX_MSG_MAP(CPDFSplit)
	ON_BN_CLICKED(IDC_CHECK_SAMEASSOURCE, OnCheckSameassource)
	ON_BN_CLICKED(ID_ABOUT, OnAbout)
	ON_BN_CLICKED(IDC_BUTTON_BROWER, OnButtonBrower)
	ON_BN_CLICKED(IDC_BUTTON_VIEW, OnButtonView)
	ON_BN_CLICKED(IDC_BUTTON_VIEW2, OnButtonView2)
	ON_BN_CLICKED(IDC_BUTTON_BROWER_DIR, OnButtonBrowerDir)
	ON_BN_CLICKED(IDC_RADIO_SPLITALL, OnRadioSplitall)
	ON_BN_CLICKED(IDC_RADIO_SPLITPAGE, OnRadioSplitpage)
	ON_BN_CLICKED(ID_RUN, OnRun)
	ON_BN_CLICKED(ID_REGISTER, OnRegister)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPDFSplit message handlers
/*
int NTSystemCommand(const char *command)
{
	char
		local_command[4096];
	
	DWORD
		child_status;
	
	int
		status;
	
	PROCESS_INFORMATION
		process_info;
	
	STARTUPINFO
		startup_info;
	
	unsigned int
		background_process;
	
	if (command == (char *) NULL)
		return(-1);
	GetStartupInfo(&startup_info);
	startup_info.dwFlags=STARTF_USESHOWWINDOW;
	startup_info.wShowWindow=SW_HIDE;
	(void) strcpy(local_command,command);
	background_process=command[strlen(command)-1] == '&';
	if (background_process)
		local_command[strlen(command)-1]='\0';
	if (command[strlen(command)-1] == '|')
		local_command[strlen(command)-1]='\0';
	else
		startup_info.wShowWindow=SW_HIDE;

	status=CreateProcess((LPCTSTR) NULL,local_command,
		(LPSECURITY_ATTRIBUTES) NULL,(LPSECURITY_ATTRIBUTES) NULL,(BOOL) FALSE,
		(DWORD) NORMAL_PRIORITY_CLASS,(LPVOID) NULL,(LPCSTR) NULL,&startup_info,
		&process_info);

	if (status == 0)
		return(-1);
	if (background_process)
		return(status == 0);
	status=WaitForSingleObject(process_info.hProcess,INFINITE);
	if (status != WAIT_OBJECT_0)
		return(status);
	status=GetExitCodeProcess(process_info.hProcess,&child_status);
	if (status == 0)
		return(-1);
	CloseHandle(process_info.hProcess);
	CloseHandle(process_info.hThread);
	return((int) child_status);
}
*/
void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

void CPDFSplit::OnOK() 
{
	UpdateData();
	AfxGetApp()->WriteProfileString("CPDFSplit","m_strSourcePDF",m_strSourcePDF);
	AfxGetApp()->WriteProfileString("CPDFSplit","m_strPageOption",m_strPageOption);
	AfxGetApp()->WriteProfileString("CPDFSplit","m_strOutputDir",m_strOutputDir);
	AfxGetApp()->WriteProfileInt("CPDFSplit","m_bCheckOutput",m_bCheckOutput);
	AfxGetApp()->WriteProfileInt("CPDFSplit","m_bSplitAllPages",m_bSplitAllPages);
}

BOOL IsRegistered = TRUE;
BOOL CPDFSplit::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_strSourcePDF = AfxGetApp()->GetProfileString("CPDFSplit","m_strSourcePDF");
	m_strPageOption = AfxGetApp()->GetProfileString("CPDFSplit","m_strPageOption","1");
	m_strOutputDir = AfxGetApp()->GetProfileString("CPDFSplit","m_strOutputDir","C:\\");
	m_bCheckOutput = AfxGetApp()->GetProfileInt("CPDFSplit","m_bCheckOutput",FALSE);
	m_bSplitAllPages = AfxGetApp()->GetProfileInt("CPDFSplit","m_bSplitAllPages",TRUE);
	Update();

	IsRegistered = TRUE;
	if(IsRegistered)
		GetDlgItem(ID_REGISTER)->SetWindowText("Homepage");	
	else
		GetDlgItem(ID_REGISTER)->SetWindowText("Purchase");
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPDFSplit::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CPropertyPage::OnCancel();
}

void CPDFSplit::OnCheckSameassource() 
{
	UpdateData();
	Update();
}

void CPDFSplit::OnAbout() 
{
	CAbout m_dlgAbout;
	m_dlgAbout.DoModal();
}

void CPDFSplit::OnButtonBrower() 
{
	char *szTitle = "Select PDF File";
	char *sFilter = "PDF Files (*.PDF)|*.PDF|All Files (*.*)|*.*||";
	CFileDialog m_dlgFile(TRUE,szTitle,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,sFilter,NULL);
	if(m_dlgFile.DoModal() == IDOK)
	{
		UpdateData();
		m_strSourcePDF = m_dlgFile.GetPathName();
		Update();
	}	
}

void CPDFSplit::OnButtonView() 
{
	UpdateData();
	if(m_strSourcePDF.GetLength() > 0)
		ShellExecute(m_hWnd,"open",m_strSourcePDF,NULL,NULL,SW_SHOWNORMAL);	
}

void CPDFSplit::OnButtonView2() 
{
	UpdateData();
	if(m_strOutputDir.GetLength() > 0)
		ShellExecute(m_hWnd,"open",m_strOutputDir,NULL,NULL,SW_SHOWNORMAL);	
}

void CPDFSplit::OnButtonBrowerDir() 
{
	UpdateData();
	if(!m_bSplitAllPages)
	{
		char *szTitle = "Select PDF File";
		char *sFilter = "PDF Files (*.PDF)|*.PDF||";
		CFileDialog m_dlgFile(FALSE,szTitle,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,sFilter,NULL);
		if(m_dlgFile.DoModal() == IDOK)
		{
			m_strOutputDir = m_dlgFile.GetPathName();
			Update();
		}	
	}
	else
	{
		CSBDestination sb(m_hWnd,IDS_BROWDIRTITLE_E);
		sb.SetFlags(BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT);
		sb.SetInitialSelection(m_strOutputDir);
		if (sb.SelectFolder())
		{
			m_strOutputDir = sb.GetSelectedFolder();
			if(!m_bCheckOutput)
			{
				if(m_strOutputDir[m_strOutputDir.GetLength()-1] != '\\')
					m_strOutputDir += "\\";
				m_strOutputDir += "pg";
			}
			Update();
		}
	}
}

void CPDFSplit::OnRadioSplitall() 
{
	m_bSplitAllPages = TRUE;
	Update();
}

void CPDFSplit::OnRadioSplitpage() 
{
	m_bSplitAllPages = FALSE;
	Update();
}
void CPDFSplit::Update() 
{
	((CButton*)GetDlgItem(IDC_RADIO_SPLITALL))->SetCheck(m_bSplitAllPages);
	((CButton*)GetDlgItem(IDC_RADIO_SPLITPAGE))->SetCheck(!m_bSplitAllPages);
	GetDlgItem(IDC_EDIT_PAGES_OPTION)->EnableWindow(!m_bSplitAllPages);
	if(m_bCheckOutput)
	{
		GetDlgItem(IDC_EDIT_OUTPUTDIR)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_BROWER_DIR)->EnableWindow(FALSE);

		char fname[_MAX_PATH];
		if(m_strSourcePDF.GetLength() > 0)
		{
			char path_buffer[_MAX_PATH];
			char drive[_MAX_DRIVE];
			char dir[_MAX_DIR];
			char ext[_MAX_EXT];
			_splitpath(m_strSourcePDF, drive, dir, fname, ext );
			_makepath(path_buffer,drive, dir,"","");
			if(path_buffer[strlen(path_buffer)-1] != '\\')
				strcat(path_buffer,"\\");
			m_strOutputDir = path_buffer;
		}
		if(m_bSplitAllPages)
		{
			m_strOutputDir += "pg";
		}
		else
		{
			m_strOutputDir += "PageFrom_";
			m_strOutputDir += fname;
			m_strOutputDir += ".pdf";
		}
	}
	else
	{
		GetDlgItem(IDC_EDIT_OUTPUTDIR)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_BROWER_DIR)->EnableWindow(TRUE);
	}
	UpdateData(FALSE);
}

void CPDFSplit::OnRun() 
{
	UpdateData();
	if(m_strSourcePDF.GetLength() <= 0)
		return;
	char commandline[1024];
	GetModulePath(commandline,"pdfpg.exe");

	//C:\A.pdf,-20,50 C:\merged.pdf
	if(m_strOutputDir.GetLength() == 0)
		return;
	if(m_bSplitAllPages)
	{
		strcat(commandline," burst ");

		strcat(commandline,"\"");
		strcat(commandline,m_strSourcePDF);
		strcat(commandline,"\"");

		strcat(commandline," \"");
		strcat(commandline,m_strOutputDir);
		strcat(commandline,"\"");
	}
	else
	{
		strcat(commandline," \"");
		strcat(commandline,m_strSourcePDF);
		strcat(commandline,",");
		strcat(commandline,m_strPageOption);
		strcat(commandline,"\"");

		strcat(commandline," \"");
		strcat(commandline,m_strOutputDir);
		strcat(commandline,"\"");
	}
	CRedirect	*m_pRedirect;
	m_pRedirect = new CRedirect(commandline,  &m_ctrlLogOutput);
	SetItemsStatus(FALSE);
	m_pRedirect->Run();
	delete m_pRedirect;
	m_pRedirect = 0;
	SetItemsStatus(TRUE);
}
void CPDFSplit::SetItemsStatus(BOOL m_bEnable)
{
	if(!m_bEnable)
		BeginWaitCursor();
	else
		EndWaitCursor();
	EnableWindow(m_bEnable);
	GetDlgItem(IDC_STATIC1)->EnableWindow(m_bEnable);
	GetDlgItem(IDC_STATIC2)->EnableWindow(m_bEnable);
	GetDlgItem(IDC_STATIC3)->EnableWindow(m_bEnable);
	GetDlgItem(IDC_EDIT_SOURCEPDF)->EnableWindow(m_bEnable);
	GetDlgItem(IDC_BUTTON_VIEW)->EnableWindow(m_bEnable);
	GetDlgItem(IDC_RADIO_SPLITALL)->EnableWindow(m_bEnable);
	GetDlgItem(IDC_RADIO_SPLITPAGE)->EnableWindow(m_bEnable);
	GetDlgItem(IDC_EDIT_PAGES_OPTION)->EnableWindow(m_bEnable);
	GetDlgItem(IDC_CHECK_SAMEASSOURCE)->EnableWindow(m_bEnable);
	GetDlgItem(IDC_EDIT_OUTPUTDIR)->EnableWindow(m_bEnable);
	GetDlgItem(IDC_BUTTON_BROWER_DIR)->EnableWindow(m_bEnable);
	GetDlgItem(IDC_BUTTON_VIEW2)->EnableWindow(m_bEnable);
	GetDlgItem(ID_RUN)->EnableWindow(m_bEnable);
	GetDlgItem(ID_ABOUT)->EnableWindow(m_bEnable);
}
void CPDFSplit::OnRegister() 
{
	if(IsRegistered)
	{
		ShellExecute(NULL,"open","http://www.verypdf.com/pdfpg",NULL,NULL,SW_SHOW);
		return;
	}
	if(IsRegistered)
		GetDlgItem(ID_REGISTER)->SetWindowText("Homepage");	
	else
		GetDlgItem(ID_REGISTER)->SetWindowText("Purchase");
}
